unit Test.UClass.TAritmeticaBasica;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}


//==============================================================================
//
//  I N T E R F A C E
//
//==============================================================================
interface

uses
  TestFramework, System.Generics.Collections, UClass.TAritmeticaBasica;

type
  // Test methods for class TAritmeticaBasica
  TestTAritmeticaBasica = class(TTestCase)
  strict private
    FAritmeticaBasica: TAritmeticaBasica;
    FFactorizacion:TIntegerList;
  public
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TestMaximoComunDivisor;
    procedure TestMinimoComunMultiplo;
  end;

  // Clase para parametrizar los test de EsNumeroPrimo
  TestTAritmeticaBasicaEsNumeroPrimo = class(TTestCase)
  strict private
    FValue:Integer;
    FEsPrimo:boolean;
    FAritmeticaBasica: TAritmeticaBasica;
  public
    constructor Create(AValue: Integer; AEsPrimo:boolean); reintroduce;
    function GetName: string; override;
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure Run;
  end;

  // Clase para parametrizar los test de Factorizacion
  TestTAritmeticaBasicaFactorizacion = class(TTestCase)
  strict private
    FValue, FCount:Integer;
    FAritmeticaBasica: TAritmeticaBasica;
  public
    constructor Create(AValue: Integer; ACount:Integer); reintroduce;
    function GetName: string; override;
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure Run;
  end;

//==============================================================================
//
//  I M P L E M E N T A C I O N
//
//==============================================================================
implementation

uses
  System.SysUtils;



procedure TestTAritmeticaBasica.SetUp;
begin
  // Crear el objeto que vamos a probar
  FAritmeticaBasica := TAritmeticaBasica.Create;
  FFactorizacion := TIntegerList.Create;
end;

procedure TestTAritmeticaBasica.TearDown;
begin
  // Liberar el objeto de prueba
  FAritmeticaBasica.Free;
  FAritmeticaBasica := nil;
  FreeAndNil(FFactorizacion);
end;

procedure TestTAritmeticaBasica.TestMaximoComunDivisor;
var
  ReturnValue: Int64;
  ANumero2: Int64;
  ANumero1: Int64;
begin
  ReturnValue := FAritmeticaBasica.MaximoComunDivisor(ANumero1, ANumero2);
end;

procedure TestTAritmeticaBasica.TestMinimoComunMultiplo;
var
  ReturnValue: Int64;
  ANumero2: Int64;
  ANumero1: Int64;
begin
  ReturnValue := FAritmeticaBasica.MinimoComunMultiplo(ANumero1, ANumero2);
end;


{ TestTAritmeticaBasicaFactorizacion }
constructor TestTAritmeticaBasicaFactorizacion.Create(AValue: Integer; ACount:Integer);
begin
  inherited Create('Run');
  FValue := AValue;
  FCount := ACount;
end;

function TestTAritmeticaBasicaFactorizacion.GetName: string;
begin
  Result := Format('TestFactorizacion_Numero_%.3d', [FValue]);
end;


procedure TestTAritmeticaBasicaFactorizacion.Run;
var
  FFactorizacion:TIntegerList;
begin
  FFactorizacion := TIntegerList.Create;
  try
    FAritmeticaBasica.Factorizacion(FValue, FFactorizacion);
    CheckTrue((FFactorizacion.Count = FCount) , Format('Se esperaban %d factores y se han obtenido %d',[FCount, FFactorizacion.Count]));
  finally
    FreeAndNil(FFactorizacion);
  end;
end;

procedure TestTAritmeticaBasicaFactorizacion.SetUp;
begin
  inherited;
  FAritmeticaBasica := TAritmeticaBasica.Create;
end;

procedure TestTAritmeticaBasicaFactorizacion.TearDown;
begin
  FreeAndNil(FAritmeticaBasica);
  inherited;
end;

procedure RegisterTestFactorizacion;
begin
  // Registrar test parametrizados de Factiorizacion
  RegisterTest('TestFactorizacion_Especiales', TestTAritmeticaBasicaFactorizacion.Create(0, 0));
  RegisterTest('TestFactorizacion_Especiales', TestTAritmeticaBasicaFactorizacion.Create(1, 0));
  RegisterTest('TestFactorizacion_Param', TestTAritmeticaBasicaFactorizacion.Create(2, 1));
  RegisterTest('TestFactorizacion_Param', TestTAritmeticaBasicaFactorizacion.Create(10, 2));
  RegisterTest('TestFactorizacion_Param', TestTAritmeticaBasicaFactorizacion.Create(18, 3));
  RegisterTest('TestFactorizacion_Param', TestTAritmeticaBasicaFactorizacion.Create(528, 6));
end;


{ TestTAritmeticaBasicaEsNumeroPrimo }
constructor TestTAritmeticaBasicaEsNumeroPrimo.Create(AValue: Integer; AEsPrimo:boolean);
begin
  inherited Create('Run');
  FValue := AValue;
  FEsPrimo := AEsPrimo;
end;

function TestTAritmeticaBasicaEsNumeroPrimo.GetName: string;
begin
  Result := Format('TestEsNumeroPrimo_Numero_%.3d', [FValue]);
end;

procedure TestTAritmeticaBasicaEsNumeroPrimo.Run;
var
  b:boolean;
begin
  b := FAritmeticaBasica.EsNumeroPrimo(FValue);
  Check((b = FEsPrimo), Format('Se esperaba que el nmero <%d> devolviera un resultado <%s>.',[FValue, BoolToStr(FEsPrimo)]));
end;

procedure TestTAritmeticaBasicaEsNumeroPrimo.SetUp;
begin
  inherited;
  FAritmeticaBasica := TAritmeticaBasica.Create;
end;

procedure TestTAritmeticaBasicaEsNumeroPrimo.TearDown;
begin
  FreeAndNil(FAritmeticaBasica);
  inherited;
end;

procedure RegisterTestEsNumeroPrimo;
begin
  // Registrar test parametrizados de EsNumeroPrimo
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(0, False));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(1, True));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(2, True));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(3, True));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(4, False));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(11, True));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(17, True));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(18, False));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(20, False));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(331, True));
  RegisterTest('TestEsNumeroPrimo', TestTAritmeticaBasicaEsNumeroPrimo.Create(5557, True));
end;


//==============================================================================
//
//  I N I T I A L I Z A T I O N
//
//==============================================================================
initialization
  // Register any test cases with the test runner
  RegisterTest(TestTAritmeticaBasica.Suite);
  // Registrar una batera de tests parametrizados para Factorizacion
  RegisterTestFactorizacion;
  // Registrar una batera de tests parametrizados para EsNumeroPrimo
  RegisterTestEsNumeroPrimo;

end.

